<?php

final class TagManager
{

    const BASE_PATH = "./data/tags";

    public static function getTags(): array
    {
        $tags = [];
        foreach (array_diff(scandir(self::BASE_PATH), [".", ".."]) as $file) {
            $tags[] = $file;
        }
        return $tags;
    }

    public static function getFromTag(string $tag): array
    {
        return file(self::BASE_PATH . "/$tag", FILE_IGNORE_NEW_LINES);
    }

    public static function add(array $tags, string $fullref)
    {
        foreach ($tags as $tag) {
            $tagfile = self::BASE_PATH . "/$tag";
            if (is_file($tagfile) and strpos(file_get_contents($tagfile), $fullref) !== false) {
                continue;
            }
            file_put_contents($tagfile, "$fullref\n", FILE_APPEND);
        }
    }

}
